org.apache.lucene.analysis.fr

## Class FrenchAnalyzer

- java.lang.Object
- - org.apache.lucene.analysis.Analyzer
  - - org.apache.lucene.analysis.util.StopwordAnalyzerBase
    - - org.apache.lucene.analysis.fr.FrenchAnalyzer

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public final class FrenchAnalyzer
      extends StopwordAnalyzerBase

  `Analyzer` for French language.

  Supports an external list of stopwords (words that will not be indexed at all) and an external list of exclusions (word that will not be stemmed, but indexed). A default set of stopwords is used unless an alternative list is specified, but the exclusion list is empty by default.

  You must specify the required `Version` compatibility when creating FrenchAnalyzer:

  - As of 3.6, FrenchLightStemFilter is used for less aggressive stemming.
  - As of 3.1, Snowball stemming is done with SnowballFilter, LowerCaseFilter is used prior to StopFilter, and ElisionFilter and Snowball stopwords are used by default.
  - As of 2.9, StopFilter preserves position increments

  NOTE: This class uses the same `Version` dependent settings as `StandardAnalyzer`.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer

      `Analyzer.GlobalReuseStrategy, Analyzer.PerFieldReuseStrategy, Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static CharArraySet` | `DEFAULT_ARTICLES` Default set of articles for ElisionFilter
    `static String` | `DEFAULT_STOPWORD_FILE` File containing default French stopwords.

    - ### Fields inherited from class org.apache.lucene.analysis.util.StopwordAnalyzerBase

      `matchVersion, stopwords`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FrenchAnalyzer(Version matchVersion)` Builds an analyzer with the default stop words (`getDefaultStopSet()`).
    `FrenchAnalyzer(Version matchVersion, CharArraySet stopwords)` Builds an analyzer with the given stop words
    `FrenchAnalyzer(Version matchVersion, CharArraySet stopwords, CharArraySet stemExclutionSet)` Builds an analyzer with the given stop words

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Analyzer.TokenStreamComponents` | `createComponents(String fieldName, Reader reader)` Creates `Analyzer.TokenStreamComponents` used to tokenize all the text in the provided `Reader`.
    `static CharArraySet` | `getDefaultStopSet()` Returns an unmodifiable instance of the default stop-words set.

    - ### Methods inherited from class org.apache.lucene.analysis.util.StopwordAnalyzerBase

      `getStopwordSet, loadStopwordSet, loadStopwordSet, loadStopwordSet`

    - ### Methods inherited from class org.apache.lucene.analysis.Analyzer

      `close, getOffsetGap, getPositionIncrementGap, initReader, tokenStream`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_STOPWORD_FILE

          public static final String DEFAULT_STOPWORD_FILE

      File containing default French stopwords.
      See Also:
        Constant Field Values

    - #### DEFAULT_ARTICLES

          public static final CharArraySet DEFAULT_ARTICLES

      Default set of articles for ElisionFilter

  - ### Constructor Detail

    - #### FrenchAnalyzer

          public FrenchAnalyzer(Version matchVersion)

      Builds an analyzer with the default stop words (`getDefaultStopSet()`).

    - #### FrenchAnalyzer

          public FrenchAnalyzer(Version matchVersion,
                        CharArraySet stopwords)

      Builds an analyzer with the given stop words
      Parameters:
        `matchVersion` - lucene compatibility version
        `stopwords` - a stopword set

    - #### FrenchAnalyzer

          public FrenchAnalyzer(Version matchVersion,
                        CharArraySet stopwords,
                        CharArraySet stemExclutionSet)

      Builds an analyzer with the given stop words
      Parameters:
        `matchVersion` - lucene compatibility version
        `stopwords` - a stopword set
        `stemExclutionSet` - a stemming exclusion set

  - ### Method Detail

    - #### getDefaultStopSet

          public static CharArraySet getDefaultStopSet()

      Returns an unmodifiable instance of the default stop-words set.
      Returns:
        an unmodifiable instance of the default stop-words set.

    - #### createComponents

          protected Analyzer.TokenStreamComponents createComponents(String fieldName,
                                                        Reader reader)

      Creates `Analyzer.TokenStreamComponents` used to tokenize all the text in the provided `Reader`.
      Specified by:
        `createComponents` in class `Analyzer`
      Returns:
        `Analyzer.TokenStreamComponents` built from a `StandardTokenizer` filtered with `StandardFilter`, `ElisionFilter`, `LowerCaseFilter`, `StopFilter`, `KeywordMarkerFilter` if a stem exclusion set is provided, and `FrenchLightStemFilter`

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.